/*********** AVR155 : AVRTWIgpI2C LCD\ւ̱@ ***************

޲		: ATmega163

̧ٖ		: LCD_control.c

Ŕԍ		: 1.0

		: ̉pLqTWI޽ ѓI2C޽PhilipsLCDƒʐM@
			  Lq܂BLCD\\ݒ肵Đ䂷"LCD_control.c
			  "޲֌WɕĂ܂B

			  ȉ̕@܂B
				- \̍\ݒ
				- \ւ̕񏑂
				- ۰ٕ쐬̂߂ɕ\ꂽ̍ړ
				- \킩̏ԏǂݍ

			  I2C޽ɑ΂ʐMɊւĂAVRʰ޳TWIgpAײނ
			  ʂĂ𱸾܂Bײނ"TWI_driver.c"ŋLq܂B

			  ̉p͊PhilipsPCF2119RU I2C "׽"LCD쓮
			  Batron BT21605V-SRE-I2C-COG LCDӼޭقgp܂B

		: Asmund Saetre

ύXL^	: 2000N125쐬 AS

******************************************************************************/
#include "LCD_control.h"

/******************************************************************************
 \p÷ĕ`
******************************************************************************/
//flash char	String1[] ={"AVR mega163 TWI"};
flash char	String1[] ={"AVR ATmega163 with TWI interface to I2C"};

/******************************************************************************
 ֐ : char setup(void)
 AVR\ݒٰ
******************************************************************************/
char setup(void)
{
  Init_TWI();								// TWI(TWI_driver.c)
  return 1;
}

/******************************************************************************
 ֐ : unsigned char Clear_LCD(void)
 Philips쓮̓ASCII\͕ψʂA\͕\ȂɌ悤ɂ
 ܂B\ȂɌ悤ɂɂDDRAM"SPACE"+ASCII_OFFSET܂ޕKv
 ܂B
******************************************************************************/
unsigned char Clear_LCD(void)
{
  char temp0[2];
  char temp1[(CHAR_PER_ROW*NR_ROW)+1];
  char temp2[2];
  char state,i;
  tx_type tx_frame[4];

  state = SUCCESS;							// ߂l

  // z\0
  tx_frame[0].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[0].size = 2;						// M޲Đw
  tx_frame[0].data_ptr = temp0;				// ꎞz0߲w
  tx_frame[0].data_ptr[0] = FUNC_SET;		// ꎞz0ɋ@\ݒI𕄍ݒ
  tx_frame[0].data_ptr[1] = CLR_LCD;		// ꎞz0ɕ\DDRAMڽv=0w蕄ݒ
  // z\1
  tx_frame[1].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[1].size = ((CHAR_PER_ROW*NR_ROW)+1);	// M޲Đw
  tx_frame[1].data_ptr = temp1;				// ꎞz1߲w
  tx_frame[1].data_ptr[0] = DDRAM_WR;		// ꎞz1DDRAMݕݒ
  for(i=1;i<((CHAR_PER_ROW*NR_ROW)+1);i++)	// ꎞz1ɋ󔒂ƂȂ镄Kvݒ
	tx_frame[1].data_ptr[i] = (' '+ASCII_OFFSET);
  // z\2
  tx_frame[2].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[2].size = 2;						// M޲Đw
  tx_frame[2].data_ptr = temp2;				// ꎞz2߲w
  tx_frame[2].data_ptr[0] = RS_CONT;		// ꎞz2LCD޲ ݒ
  tx_frame[2].data_ptr[1] = CLR_ADR;		// ꎞz2DDRAMڽv=0w蕄ݒ
  // z\3
  tx_frame[3].slave_adr = OWN_ADR;			// g̱ڽw(Iq)

  state =Send_to_TWI(tx_frame);				// LCD\s(TWI_driver.c)
  return state;								// ԕƋɕA
}

/******************************************************************************
 ֐ : unsigned char Init_LCD(void)
 /_łȂ2s16LCD\ݒBDDRAMݖDDRAMڽisA
 ̕\ړȂɐݒB\ADDRAMڽv=0B
******************************************************************************/
unsigned char Init_LCD(void)
{
  char temp[5];
  char state;
  tx_type tx_frame[2];

  state = SUCCESS;							// ߂l

  // z\0
  tx_frame[0].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[0].size = 5;						// M޲Đw
  tx_frame[0].data_ptr = temp;				// ꎞz߲w
  tx_frame[0].data_ptr[0] = FUNC_SET;		// ꎞzɋ@\ݒI𕄍ݒ
  tx_frame[0].data_ptr[1] = 0x34;			// ꎞz2s16\ݒ
  tx_frame[0].data_ptr[2] = 0x0C;			// ꎞzɶقȂ\ONݒ
  tx_frame[0].data_ptr[3] = 0x06;			// ꎞzɏݖ̶ِisݒ
  tx_frame[0].data_ptr[4] = CLR_LCD;		// ꎞzɕ\DDRAMڽv=0w蕄ݒ
  // z\1
  tx_frame[1].slave_adr = OWN_ADR;			// g̱ڽw(Iq)

  state =Send_to_TWI(tx_frame);				// LCDs(TWI_driver.c)
  return state;								// ԕƋɕA
}

/******************************************************************************
 ֐ : unsigned char Write_String1(void)
 LCDDDRAM֕AʒuLCDJnʒu(LCD̍[DDRAM
 u0)֖߂܂B
******************************************************************************/
unsigned char Write_String1(void)
{
  char temp0[2];
  char temp1[sizeof(String1)];
  char temp2[2];
  char state,i,adr;
  tx_type tx_frame[4];

  state = SUCCESS;							// ߂l
  adr = 0;									// 0Ԓn(ʒu)

  // z\0
  tx_frame[0].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[0].size = 2;						// M޲Đw
  tx_frame[0].data_ptr = temp0;				// ꎞz0߲w
  tx_frame[0].data_ptr[0] = FUNC_SET;		// ꎞz0ɋ@\ݒI𕄍ݒ
  tx_frame[0].data_ptr[1] = DDRAM_ADR + adr;	// ꎞz0DDRAMʒulݒ
  // z\1
  tx_frame[1].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[1].size = (sizeof(String1));		// M޲Đw
  tx_frame[1].data_ptr = temp1;				// ꎞz1߲w
  tx_frame[1].data_ptr[0] = DDRAM_WR;		// ꎞz1DDRAMݕݒ
  memcpy_P(tx_frame[1].data_ptr+1,String1,(tx_frame[1].size-1));	// ꎞz1֕񕡎
  for(i=1;i<(tx_frame[1].size);i++)			// ʕASCIIψʉZ
	tx_frame[1].data_ptr[i] += ASCII_OFFSET;
  // z\2
  tx_frame[2].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[2].size = 2;						// M޲Đw
  tx_frame[2].data_ptr = temp2;				// ꎞz2߲w
  tx_frame[2].data_ptr[0] = RS_CONT;		// ꎞz2LCD޲ ݒ
  tx_frame[2].data_ptr[1] = CLR_ADR;		// ꎞz2DDRAMڽv=0w蕄ݒ
  // z\3
  tx_frame[3].slave_adr = OWN_ADR;			// g̱ڽw(Iq)

  state =Send_to_TWI(tx_frame);				// \㶰وʒuAs(TWI_driver.c)
  return state;								// ԕƋɕA
}

/******************************************************************************
 ֐ : unsigned char Read_LCD_controlreg(void)
 LCD޲ēǂݍ
	ޯ7	 : Z׸(BF,삪s邱Ƃ)
	ޯ6`0 : DDRAMڽv(AC)
******************************************************************************/
unsigned char Read_LCD_controlreg(void)
{
  char state;
  char temp;
  tx_type tx_frame[3];

  state = SUCCESS;							// ߂l

  // z\0
  tx_frame[0].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[0].size = 1;						// M޲Đw
  tx_frame[0].data_ptr = &temp;				// ꎞϐ̱ڽւ߲w
  tx_frame[0].data_ptr[0] = READ_CONT_REG;	// ꎞϐLCDZ׸ނAC̱w蕄ݒ
  // z\1
  tx_frame[1].slave_adr = LCD_ADR+R;		// ]uڽ+ǂݍݎw
  tx_frame[1].size = 1;						// M޲Đw
  tx_frame[1].data_ptr = &temp;				// ꎞϐ̱ڽւ߲w
  // z\2
  tx_frame[2].slave_adr = OWN_ADR;			// g̱ڽw(Iq)

  state =Send_to_TWI(tx_frame);				// LCD瑽Z׸ނACǂݍݎs(TWI_driver.c)
  if(state != SUCCESS)						// sȂA
	return state;							// TWSRԕƋɕA
  return temp;								// LCD擾lƋɕA
}

/******************************************************************************
 ֐ : unsigned char Shift_left(void)
 ۰ٕ쐬̂߁ADDRAM̕\1񍶈ړB
******************************************************************************/
unsigned char Shift_left(void)
{
  char temp0[2];
  char state;
  tx_type tx_frame[2];

  state = SUCCESS;							// ߂l

  // z\0
  tx_frame[0].slave_adr = LCD_ADR+W;		// ]uڽ+ݎw
  tx_frame[0].size = 2;						// M޲Đw
  tx_frame[0].data_ptr = temp0;				// ꎞz0߲w
  tx_frame[0].data_ptr[0] = FUNC_SET;		// ꎞz0ɋ@\ݒI𕄍ݒ
  tx_frame[0].data_ptr[1] = SHIFT_LEFT;		// ꎞz0LCD1񍶈ړݒ
  // z\1
  tx_frame[1].slave_adr = OWN_ADR;			// g̱ڽw(Iq)

  state =Send_to_TWI(tx_frame);				// LCD\1񍶈ړs(TWI_driver.c)
  return state;								// ԕƋɕA
}

/******************************************************************************
 ֐ : void Delay1mS(int number_of_mS)
 4MHzł1msxJԂB"number_of_mS"͉JԂs邩m点
 ܂BႦnumber_of_mS=30003bxB
******************************************************************************/
void Delay1mS(int number_of_mS)
{
  int i;

  while(number_of_mS--)						// w񐔌JԂ
  {
	i = 0x1F3;								// 4MHzŊT1msƂȂJԂ񐔎擾
	while(i--);								// T1msԌJԂ
  }
}

/******************************************************************************
 ֐ : void C_task main (void)
 LCD𐧌䂷邽߂̎֐BLCDݒ肵ĕA۰ٕƂĂ
 ړ܂B
******************************************************************************/
void C_task main (void)
{
  char state;

  setup();   								// AVRTWIݒ

  while(Read_LCD_controlreg() & BUSY_FLAG);	// LCDҋ@
  do
  {
	state = Init_LCD();						// LCDݒ
  }while(state != SUCCESS);

  while(Read_LCD_controlreg() & BUSY_FLAG);	// LCDҋ@
  do
  {
	state = Clear_LCD();    				// LCD\
  }while(state != SUCCESS);

  while(Read_LCD_controlreg() & BUSY_FLAG);	// LCDҋ@
  do
  {
	state =  Write_String1();    			// LCD\
  }while(state != SUCCESS);

//	Delay1mS(500);							// 0.5bx

  for(;;)									// ۰ٍ쐬
  {
	Delay1mS(500);							// 0.5bx
	while(Read_LCD_controlreg() & BUSY_FLAG);	// LCDҋ@
	Shift_left();							// LCD\1ړ
  }
}
